## globjects 1.0.0

=== source/examples/ssbo/CMakeLists.txt ===

# 
# External dependencies
# 

find_package(GLFW)
find_package(glbinding REQUIRED)


# 
# Executable name and options
# 

# Target name
set(target ssbo)

# Exit here if required dependencies are not met
if (NOT GLFW_FOUND)
    message("Example ${target} skipped: GLFW not found")
    return()
endif()

message(STATUS "Example ${target}")


# 
# Sources
# 

set(sources
    main.cpp

    ScreenAlignedQuad.h
    ScreenAlignedQuad.cpp
    datapath.inl
)


# 
# Create executable
# 

# Build executable
add_executable(${target}
    ${sources}
)

# Create namespaced alias
add_executable(${META_PROJECT_NAME}::${target} ALIAS ${target})


# 
# Project options
# 

set_target_properties(${target}
    PROPERTIES
    ${DEFAULT_PROJECT_OPTIONS}
    FOLDER "${IDE_FOLDER}"
)


# 
# Include directories
# 

target_include_directories(${target}
    PRIVATE
    ${DEFAULT_INCLUDE_DIRECTORIES}
    ${PROJECT_BINARY_DIR}/source/include
    SYSTEM
    ${GLFW_INCLUDE_DIR}
)


# 
# Libraries
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LIBRARIES}
    ${GLFW_LIBRARIES}
    ${META_PROJECT_NAME}::globjects
    cpplocate::cpplocate
)


# 
# Compile definitions
# 

target_compile_definitions(${target}
    PRIVATE
    ${DEFAULT_COMPILE_DEFINITIONS}
    GLFW_INCLUDE_NONE
)


# 
# Compile options
# 

target_compile_options(${target}
    PRIVATE
    ${DEFAULT_COMPILE_OPTIONS}
)


# 
# Linker options
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LINKER_OPTIONS}
)


# 
# Deployment
# 

# Executable
install(TARGETS ${target}
    RUNTIME DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
    BUNDLE  DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
)

=== source/examples/tessellation/CMakeLists.txt ===

# 
# External dependencies
# 

find_package(GLFW)
find_package(glbinding REQUIRED)


# 
# Executable name and options
# 

# Target name
set(target tessellation)

# Exit here if required dependencies are not met
if (NOT GLFW_FOUND)
    message("Example ${target} skipped: GLFW not found")
    return()
endif()

message(STATUS "Example ${target}")


# 
# Sources
# 

set(sources
    main.cpp

    Icosahedron.h
    Icosahedron.cpp
    datapath.inl
)


# 
# Create executable
# 

# Build executable
add_executable(${target}
    ${sources}
)

# Create namespaced alias
add_executable(${META_PROJECT_NAME}::${target} ALIAS ${target})


# 
# Project options
# 

set_target_properties(${target}
    PROPERTIES
    ${DEFAULT_PROJECT_OPTIONS}
    FOLDER "${IDE_FOLDER}"
)


# 
# Include directories
# 

target_include_directories(${target}
    PRIVATE
    ${DEFAULT_INCLUDE_DIRECTORIES}
    ${PROJECT_BINARY_DIR}/source/include
    SYSTEM
    ${GLFW_INCLUDE_DIR}
)


# 
# Libraries
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LIBRARIES}
    ${GLFW_LIBRARIES}
    ${META_PROJECT_NAME}::globjects
    cpplocate::cpplocate
)


# 
# Compile definitions
# 

target_compile_definitions(${target}
    PRIVATE
    ${DEFAULT_COMPILE_DEFINITIONS}
    GLFW_INCLUDE_NONE
)


# 
# Compile options
# 

target_compile_options(${target}
    PRIVATE
    ${DEFAULT_COMPILE_OPTIONS}
)


# 
# Linker options
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LINKER_OPTIONS}
)


# 
# Deployment
# 

# Executable
install(TARGETS ${target}
    RUNTIME DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
    BUNDLE  DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
)

=== debian/changelog ===
globjects (1.0.0-2) unstable; urgency=medium

  * Fix packaging testsuite failure.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 25 Nov 2016 11:32:31 +0000

globjects (1.0.0-1) unstable; urgency=medium

  * New upstream version 1.0.0
  * Refresh patch queue.
  * Upgrade packaging to debhelper 10.
  * Bump soname of shared library packages.
  * Update upstream copyright.
  * Release to unstable.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 21 Nov 2016 12:11:55 +0000

globjects (0.5.0-1) experimental; urgency=low

  * Initial release. (Closes: #837464)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 17 Sep 2016 16:51:56 +0100

=== debian/control ===
Source: globjects
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake (>= 3.0),
               debhelper (>= 10),
               libglbinding-dev,
               libglm-dev 
Build-Depends-Indep: doxygen
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/globjects.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/globjects.git
Homepage: https://github.com/cginternals/globjects

Package: libglobjects1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: cross-platform C++ wrapper for OpenGL API objects
 globjects provides object-oriented interfaces to the OpenGL API (3.0 and
 higher). The main goals are much reduced code to use OpenGL in your
 rendering software and fewer errors due to the underlying glbinding and
 further abstraction levels on top. Typical processes are automated and
 missing features in the used OpenGL driver are partially simulated or
 even emulated.
 .
 This package provides the shared libraries.

Package: libglobjects-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libglbinding-dev,
         libglobjects1 (= ${binary:Version})
Suggests: globjects-doc
Description: development files for globjects
 globjects provides object-oriented interfaces to the OpenGL API (3.0 and
 higher). The main goals are much reduced code to use OpenGL in your
 rendering software and fewer errors due to the underlying glbinding and
 further abstraction levels on top. Typical processes are automated and
 missing features in the used OpenGL driver are partially simulated or
 even emulated.
 .
 This package provides the development files.

Package: globjects-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         fonts-font-awesome,
         libjs-bootstrap,
         libjs-jquery
Description: documentation for globjects
 globjects provides object-oriented interfaces to the OpenGL API (3.0 and
 higher). The main goals are much reduced code to use OpenGL in your
 rendering software and fewer errors due to the underlying glbinding and
 further abstraction levels on top. Typical processes are automated and
 missing features in the used OpenGL driver are partially simulated or
 even emulated.
 .
 This package provides the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Possible overlinkage in the library.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILD_OPTIONS = -DBUILD_SHARED_LIBS=ON \
		-DOPTION_SELF_CONTAINED=OFF \
		-DOPTION_BUILD_EXAMPLES=OFF \
		-DOPTION_ERRORS_AS_EXCEPTION=OFF

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS += -DOPTION_BUILD_TESTS=ON
else
BUILD_OPTIONS += -DOPTION_BUILD_TESTS=OFF
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(BUILD_OPTIONS) -DOPTION_BUILD_DOCS=OFF

override_dh_auto_configure-indep:
	dh_auto_configure -- $(BUILD_OPTIONS) -DOPTION_BUILD_DOCS=ON

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

=== debian/tests/control ===
Tests: globjects-tests
Depends: @, cmake, g++ | c++-compiler

## globjects 1.1.0

=== CMakeLists.txt ===

# 
# CMake options
# 

# CMake version
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)

# Include cmake modules

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")


include(GenerateExportHeader)

set(WriterCompilerDetectionHeaderFound NOTFOUND)
# This module is only available with CMake >=3.1, so check whether it could be found
# BUT in CMake 3.1 this module doesn't recognize AppleClang as compiler, so just use it as of CMake 3.2
if (${CMAKE_VERSION} VERSION_GREATER "3.2")
    include(WriteCompilerDetectionHeader OPTIONAL RESULT_VARIABLE WriterCompilerDetectionHeaderFound)
endif()

include(cmake/GetGitRevisionDescription.cmake)
include(cmake/Custom.cmake)

# Set policies
set_policy(CMP0028 NEW) # ENABLE CMP0028: Double colon in target name means ALIAS or IMPORTED target.
set_policy(CMP0054 NEW) # ENABLE CMP0054: Only interpret if() arguments as variables or keywords when unquoted.
set_policy(CMP0042 NEW) # ENABLE CMP0042: MACOSX_RPATH is enabled by default.
set_policy(CMP0063 NEW) # ENABLE CMP0063: Honor visibility properties for all target types.


# 
# Project description and (meta) information
# 

# Get git revision
get_git_head_revision(GIT_REFSPEC GIT_SHA1)
string(SUBSTRING "${GIT_SHA1}" 0 12 GIT_REV)

# Meta information about the project
set(META_PROJECT_NAME        "globjects")
set(META_PROJECT_DESCRIPTION "Strict OpenGL objects wrapper.")
set(META_AUTHOR_ORGANIZATION "CG Internals GmbH")
set(META_AUTHOR_DOMAIN       "https://github.com/cginternals/globjects/")
set(META_AUTHOR_MAINTAINER   "opensource@cginternals.com")
set(META_VERSION_MAJOR       "1")
set(META_VERSION_MINOR       "0")
set(META_VERSION_PATCH       "0")
set(META_VERSION_REVISION    "${GIT_REV}")
set(META_VERSION             "${META_VERSION_MAJOR}.${META_VERSION_MINOR}.${META_VERSION_PATCH}")
set(META_NAME_VERSION        "${META_PROJECT_NAME} v${META_VERSION} (${META_VERSION_REVISION})")

string(MAKE_C_IDENTIFIER ${META_PROJECT_NAME} META_PROJECT_ID)
string(TOUPPER ${META_PROJECT_ID} META_PROJECT_ID)


# 
# Project configuration options
# 

# Project options
option(BUILD_SHARED_LIBS          "Build shared instead of static libraries."                    ON)
option(OPTION_SELF_CONTAINED      "Create a self-contained install with all dependencies."       OFF)
option(OPTION_BUILD_TESTS         "Build tests."                                                 ON)
option(OPTION_BUILD_DOCS          "Build documentation."                                         OFF)
option(OPTION_BUILD_EXAMPLES      "Build examples."                                              OFF)
option(OPTION_ERRORS_AS_EXCEPTION "Throw exceptions instead of printing OpenGL run-time errors." OFF)


# 
# Declare project
# 

# Generate folders for IDE targets (e.g., VisualStudio solutions)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set(IDE_FOLDER "")

# Declare project
project(${META_PROJECT_NAME} C CXX)

# Set output directories
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

# Create version file
file(WRITE "${PROJECT_BINARY_DIR}/VERSION" "${META_NAME_VERSION}")


# 
# Compiler settings and options
# 

include(cmake/CompileOptions.cmake)


# 
# Deployment/installation setup
# 

# Get project name
set(project ${META_PROJECT_NAME})

# Check for system dir install
set(SYSTEM_DIR_INSTALL FALSE)
if("${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr" OR "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local")
    set(SYSTEM_DIR_INSTALL TRUE)
endif()

# Installation paths
if(UNIX AND SYSTEM_DIR_INSTALL)
    # Install into the system (/usr/bin or /usr/local/bin)
    set(INSTALL_ROOT      "share/${project}")       # /usr/[local]/share/<project>
    set(INSTALL_CMAKE     "share/${project}/cmake") # /usr/[local]/share/<project>/cmake
    set(INSTALL_EXAMPLES  "share/${project}")       # /usr/[local]/share/<project>
    set(INSTALL_DATA      "share/${project}")       # /usr/[local]/share/<project>
    set(INSTALL_BIN       "bin")                    # /usr/[local]/bin
    set(INSTALL_SHARED    "lib")                    # /usr/[local]/lib
    set(INSTALL_LIB       "lib")                    # /usr/[local]/lib
    set(INSTALL_INCLUDE   "include")                # /usr/[local]/include
    set(INSTALL_DOC       "share/doc/${project}")   # /usr/[local]/share/doc/<project>
    set(INSTALL_SHORTCUTS "share/applications")     # /usr/[local]/share/applications
    set(INSTALL_ICONS     "share/pixmaps")          # /usr/[local]/share/pixmaps
    set(INSTALL_INIT      "/etc/init")              # /etc/init (upstart init scripts)
else()
    # Install into local directory
    set(INSTALL_ROOT      ".")                      # ./
    set(INSTALL_CMAKE     "cmake")                  # ./cmake
    set(INSTALL_EXAMPLES  ".")                      # ./
    set(INSTALL_DATA      ".")                      # ./
    set(INSTALL_BIN       ".")                      # ./
    set(INSTALL_SHARED    "lib")                    # ./lib
    set(INSTALL_LIB       "lib")                    # ./lib
    set(INSTALL_INCLUDE   "include")                # ./include
    set(INSTALL_DOC       "doc")                    # ./doc
    set(INSTALL_SHORTCUTS "misc")                   # ./misc
    set(INSTALL_ICONS     "misc")                   # ./misc
    set(INSTALL_INIT      "misc")                   # ./misc
endif()

# Set runtime path
set(CMAKE_SKIP_BUILD_RPATH            FALSE) # Add absolute path to all dependencies for BUILD
set(CMAKE_BUILD_WITH_INSTALL_RPATH    FALSE) # Use CMAKE_INSTALL_RPATH for INSTALL
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE) # Do NOT add path to dependencies for INSTALL

if(NOT SYSTEM_DIR_INSTALL)
    # Find libraries relative to binary
    if(APPLE)
        set(CMAKE_INSTALL_RPATH "@loader_path/../../../${INSTALL_LIB}")
    else()
        set(CMAKE_INSTALL_RPATH "$ORIGIN/${INSTALL_LIB}")       
    endif()
endif()


# 
# Project modules
# 

add_subdirectory(source)
add_subdirectory(docs)
add_subdirectory(deploy)


# 
# Deployment (global project files)
# 

# Install version file
install(FILES "${PROJECT_BINARY_DIR}/VERSION" DESTINATION ${INSTALL_ROOT} COMPONENT runtime)

# Install cmake find script for the project
install(FILES ${META_PROJECT_NAME}-config.cmake DESTINATION ${INSTALL_ROOT} COMPONENT dev)

# Install the project meta files
install(FILES AUTHORS   DESTINATION ${INSTALL_ROOT} COMPONENT runtime)
install(FILES LICENSE   DESTINATION ${INSTALL_ROOT} COMPONENT runtime)
install(FILES README.md DESTINATION ${INSTALL_ROOT} COMPONENT runtime)

# Install runtime data
install(DIRECTORY ${PROJECT_SOURCE_DIR}/data DESTINATION ${INSTALL_DATA} COMPONENT examples_data)

=== deploy/CMakeLists.txt ===

# 
# Target 'pack'
# 

add_custom_target(pack)
set_target_properties(pack PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD 1)


# Install additional runtime dependencies
include(${PROJECT_SOURCE_DIR}/cmake/RuntimeDependencies.cmake)


# 
# Packages
# 

include(packages/pack-globjects.cmake)


#
# Target 'component_install'
#

add_custom_target(
    component_install
    COMMAND make preinstall
    COMMAND ${CMAKE_COMMAND} -P ${PROJECT_SOURCE_DIR}/cmake/ComponentInstall.cmake
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
)

=== docs/CMakeLists.txt ===

# 
# Target 'docs'
# 

if(NOT OPTION_BUILD_DOCS)
    return()
endif()

add_custom_target(docs)


# 
# Documentation
# 

add_subdirectory(api-docs)
add_subdirectory(manual)

=== source/CMakeLists.txt ===

# 
# Configuration for all sub-projects
# 

# Generate version-header
configure_file(version.h.in ${CMAKE_CURRENT_BINARY_DIR}/include/${META_PROJECT_NAME}/${META_PROJECT_NAME}-version.h)


# 
# Sub-projects
# 

# Libraries
set(IDE_FOLDER "")
add_subdirectory(globjects)

# Examples
set(IDE_FOLDER "Examples")
add_subdirectory(examples)

# Tests
set(IDE_FOLDER "Tests")
add_subdirectory(tests)


# 
# Deployment
# 

# Deploy generated headers
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include/${META_PROJECT_NAME} DESTINATION include COMPONENT dev)

=== docs/api-docs/CMakeLists.txt ===

# 
# Find doxygen
# 

find_package(Doxygen)
if(NOT DOXYGEN_FOUND)
    message(STATUS "Disabled generation of doxygen documentation (missing doxygen).")
    return()
endif()


# 
# Target name
# 

set(target api-docs)
message(STATUS "Doc ${target}")


# 
# Input file
# 

set(doxyfile_in doxyfile.in)


# 
# Create documentation
# 

# Set project variables
set(doxyfile            "${CMAKE_CURRENT_BINARY_DIR}/doxyfile")
set(doxyfile_directory  "${CMAKE_CURRENT_BINARY_DIR}/html")
set(doxyfile_html       "${doxyfile_directory}/index.html")

# Get filename and path of doxyfile
get_filename_component(name ${doxyfile_in} NAME)
get_filename_component(path ${doxyfile_in} PATH)
if(NOT path)
    set(path ${CMAKE_CURRENT_SOURCE_DIR})
endif()

# Configure doxyfile (if it is a real doxyfile already, it should simply copy the file)
set(DOXYGEN_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
configure_file(${doxyfile_in} ${doxyfile})

# Invoke doxygen
add_custom_command(
    OUTPUT              ${doxyfile_html}
    DEPENDS             ${doxyfile} ${META_PROJECT_NAME}::globjects
    WORKING_DIRECTORY   ${path}
    COMMAND             ${CMAKE_COMMAND} -E copy_directory ${path} ${doxyfile_directory} # ToDO, configure doxygen to use source as is
    COMMAND             ${DOXYGEN} \"${doxyfile}\"
    COMMENT             "Creating doxygen documentation."
)

# Declare target
add_custom_target(${target} ALL DEPENDS ${doxyfile_html})
add_dependencies(docs ${target})


# 
# Deployment
# 

install(
    DIRECTORY ${doxyfile_directory}
    DESTINATION ${INSTALL_DOC}
    COMPONENT docs
)

=== docs/manual/CMakeLists.txt ===

# 
# Find LaTeX
# 

find_package(LATEX)
if(NOT LATEX_FOUND)
    message(STATUS "Disabled generation of documentation (missing LaTeX).")
    return()
endif()


# 
# Target name
# 

set(target docs-manual)
message(STATUS "Doc ${target}")


# 
# Input and output files
# 

set(source "${CMAKE_CURRENT_SOURCE_DIR}/globjects.tex")
set(pdf    "${CMAKE_CURRENT_BINARY_DIR}/globjects.pdf")


# 
# Create documentation
# 

# Invoke LaTeX
add_custom_command(
    OUTPUT            ${pdf}
    DEPENDS           ${source}
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    COMMAND           ${PDFLATEX_COMPILER} \"${source}\"
    COMMAND           ${PDFLATEX_COMPILER} \"${source}\"
    COMMAND           ${PDFLATEX_COMPILER} \"${source}\"
    COMMENT           "Creating LaTeX documentation."
)

# Declare target
add_custom_target(${target} ALL DEPENDS ${pdf})
add_dependencies(docs ${target})


# 
# Deployment
# 

# PDF file
install(FILES ${pdf}
    DESTINATION "${INSTALL_DOC}"
    COMPONENT docs
)

=== source/examples/CMakeLists.txt ===

# Check if examples are enabled
if(NOT OPTION_BUILD_EXAMPLES)
    return()
endif()


# 
# Configuration for all sub-projects
# 

# External packages
find_package(cpplocate)

if (NOT cpplocate_FOUND)
    message("Examples skipped: cpplocate not found")
    return()
endif()


# 
# Module information file
# 

generate_module_info(${META_PROJECT_NAME}
    VALUES
    name        "${META_PROJECT_NAME}"
    version     "${META_VERSION}"
    description "${META_PROJECT_DESCRIPTION}"
    author      "${META_AUTHOR_ORGANIZATION}"

    BUILD_VALUES
    dataPath    "${PROJECT_SOURCE_DIR}/data"

    INSTALL_VALUES
    dataPath    "\${ModulePath}/data"
)

export_module_info(${META_PROJECT_NAME}
    TARGET ${META_PROJECT_NAME}
    FOLDER "ModuleInfo"
)

install_module_info(${META_PROJECT_NAME}
    DESTINATION ${INSTALL_ROOT}
    COMPONENT examples_data
)


#
# Examples
#

add_subdirectory("commandlineoutput")
add_subdirectory("computeshader")
add_subdirectory("programpipelines")
add_subdirectory("shaderincludes")
add_subdirectory("sparsetexture")
add_subdirectory("ssbo")
add_subdirectory("states")
add_subdirectory("texture")
add_subdirectory("tessellation")
add_subdirectory("transformfeedback")

add_subdirectory("qtexample")

=== source/globjects/CMakeLists.txt ===

# 
# External dependencies
# 

find_package(GLM REQUIRED)
find_package(glbinding REQUIRED)

# 
# Library name and options
# 

# Target name
set(target globjects)

# Exit here if required dependencies are not met
message(STATUS "Lib ${target}")

# Set API export file and macro
string(MAKE_C_IDENTIFIER ${target} target_id)
string(TOUPPER ${target_id} target_id)
set(feature_file "include/${target}/${target}_features.h")
set(export_file  "include/${target}/${target}_api.h")
set(export_macro "${target_id}_API")


# 
# Sources
# 

set(include_path "${CMAKE_CURRENT_SOURCE_DIR}/include/${target}")
set(source_path  "${CMAKE_CURRENT_SOURCE_DIR}/source")

set(headers
	${include_path}/AbstractState.h
	${include_path}/AbstractState.inl
	${include_path}/AbstractUniform.h
	${include_path}/AbstractUniform.inl
	${include_path}/Buffer.h
	${include_path}/Buffer.inl
	${include_path}/Capability.h
	${include_path}/DebugMessage.h
	${include_path}/Error.h
	${include_path}/FramebufferAttachment.h
	${include_path}/Framebuffer.h
	${include_path}/glbindinglogging.h
	${include_path}/glmlogging.h
	${include_path}/globjects.h
	${include_path}/globjects.inl
	${include_path}/LocationIdentity.h
	${include_path}/logging.h
	${include_path}/NamedString.h
	${include_path}/Object.h
	${include_path}/objectlogging.h
	${include_path}/objectlogging.inl
	${include_path}/ObjectVisitor.h
	${include_path}/ProgramBinary.h
	${include_path}/Program.h
	${include_path}/Program.inl
	${include_path}/ProgramPipeline.h
	${include_path}/Query.h
	${include_path}/AttachedRenderbuffer.h
	${include_path}/Renderbuffer.h
	${include_path}/Sampler.h
	${include_path}/Shader.h
	${include_path}/State.h
	${include_path}/StateSetting.h
	${include_path}/StateSetting.inl
	${include_path}/Sync.h
	${include_path}/AttachedTexture.h
	${include_path}/Texture.h
	${include_path}/TextureHandle.h
	${include_path}/TransformFeedback.h
	${include_path}/TransformFeedback.inl
	${include_path}/UniformBlock.h
	${include_path}/Uniform.h
	${include_path}/Uniform.inl
	${include_path}/VertexArray.h
	${include_path}/VertexAttributeBinding.h
	
	${include_path}/base/AbstractStringSource.h
	${include_path}/base/AbstractFunctionCall.h
	${include_path}/base/AbstractLogHandler.h
	${include_path}/base/baselogging.h
	${include_path}/base/baselogging.inl
	${include_path}/base/Changeable.h
	${include_path}/base/ChangeListener.h
	${include_path}/base/CompositeStringSource.h
	${include_path}/base/ConsoleLogger.h
	${include_path}/base/File.h
	${include_path}/base/formatString.h
	${include_path}/base/formatString.inl
	${include_path}/base/FunctionCall.h
	${include_path}/base/FunctionCall.inl
	${include_path}/base/HeapOnly.h
	${include_path}/base/LogMessageBuilder.h
	${include_path}/base/LogMessageBuilder.inl
	${include_path}/base/LogMessage.h
	${include_path}/base/LogMessageLevel.h
	${include_path}/base/Referenced.h
	${include_path}/base/ref_ptr.h
	${include_path}/base/ref_ptr.inl
	${include_path}/base/Singleton.h
	${include_path}/base/Singleton.inl
	${include_path}/base/StaticStringSource.h
	${include_path}/base/StringSourceDecorator.h
	${include_path}/base/StringTemplate.h
)

set(sources
	${source_path}/AbstractState.cpp
	${source_path}/AbstractUniform.cpp
	${source_path}/Buffer.cpp
	${source_path}/Capability.cpp
	${source_path}/DebugMessage.cpp
	${source_path}/Error.cpp
	${source_path}/FramebufferAttachment.cpp
	${source_path}/Framebuffer.cpp
	${source_path}/glbindinglogging.cpp
	${source_path}/glmlogging.cpp
	${source_path}/globjects.cpp
	
	${source_path}/container_helpers.h
	${source_path}/container_helpers.inl
	
	${source_path}/base/AbstractFunctionCall.cpp
	${source_path}/base/AbstractStringSource.cpp
	${source_path}/base/baselogging.cpp
	${source_path}/base/Changeable.cpp
	${source_path}/base/ChangeListener.cpp
	${source_path}/base/CompositeStringSource.cpp
	${source_path}/base/ConsoleLogger.cpp
	${source_path}/base/File.cpp
	${source_path}/base/FileRegistry.cpp
	${source_path}/base/FileRegistry.h
	${source_path}/base/formatString.cpp
	${source_path}/base/HeapOnly.cpp
	${source_path}/base/LogMessageBuilder.cpp
	${source_path}/base/LogMessage.cpp
	${source_path}/base/Referenced.cpp
	${source_path}/base/StaticStringSource.cpp
	${source_path}/base/StringSourceDecorator.cpp
	${source_path}/base/StringTemplate.cpp

	${source_path}/implementations/AbstractBufferImplementation.cpp
	${source_path}/implementations/AbstractBufferImplementation.h

	${source_path}/implementations/AbstractObjectNameImplementation.h
	${source_path}/implementations/AbstractObjectNameImplementation.cpp
	${source_path}/implementations/ObjectNameImplementation_DebugKHR.h
	${source_path}/implementations/ObjectNameImplementation_DebugKHR.cpp
	${source_path}/implementations/ObjectNameImplementation_Legacy.h
	${source_path}/implementations/ObjectNameImplementation_Legacy.cpp

	${source_path}/implementations/BufferImplementation_DirectStateAccessARB.cpp
	${source_path}/implementations/BufferImplementation_DirectStateAccessARB.h
	${source_path}/implementations/BufferImplementation_DirectStateAccessEXT.cpp
	${source_path}/implementations/BufferImplementation_DirectStateAccessEXT.h
	${source_path}/implementations/BufferImplementation_Legacy.cpp
	${source_path}/implementations/BufferImplementation_Legacy.h

	${source_path}/implementations/AbstractDebugImplementation.cpp
	${source_path}/implementations/AbstractDebugImplementation.h
	${source_path}/implementations/DebugImplementation_DebugKHR.cpp
	${source_path}/implementations/DebugImplementation_DebugKHR.h
	${source_path}/implementations/DebugImplementation_Legacy.cpp
	${source_path}/implementations/DebugImplementation_Legacy.h

	${source_path}/implementations/AbstractFramebufferImplementation.cpp
	${source_path}/implementations/AbstractFramebufferImplementation.h
	${source_path}/implementations/FramebufferImplementation_DirectStateAccessARB.cpp
	${source_path}/implementations/FramebufferImplementation_DirectStateAccessARB.h
	${source_path}/implementations/FramebufferImplementation_DirectStateAccessEXT.cpp
	${source_path}/implementations/FramebufferImplementation_DirectStateAccessEXT.h
	${source_path}/implementations/FramebufferImplementation_Legacy.cpp
	${source_path}/implementations/FramebufferImplementation_Legacy.h

	${source_path}/implementations/AbstractProgramBinaryImplementation.cpp
	${source_path}/implementations/AbstractProgramBinaryImplementation.h
	${source_path}/implementations/ProgramBinaryImplementation_GetProgramBinaryARB.cpp
	${source_path}/implementations/ProgramBinaryImplementation_GetProgramBinaryARB.h
	${source_path}/implementations/ProgramBinaryImplementation_None.cpp
	${source_path}/implementations/ProgramBinaryImplementation_None.h

	${source_path}/implementations/AbstractShadingLanguageIncludeImplementation.cpp
	${source_path}/implementations/AbstractShadingLanguageIncludeImplementation.h
	${source_path}/implementations/ShadingLanguageIncludeImplementation_ShadingLanguageIncludeARB.cpp
	${source_path}/implementations/ShadingLanguageIncludeImplementation_ShadingLanguageIncludeARB.h
	${source_path}/implementations/ShadingLanguageIncludeImplementation_Fallback.cpp
	${source_path}/implementations/ShadingLanguageIncludeImplementation_Fallback.h
        
    ${source_path}/implementations/AbstractTextureImplementation.cpp
	${source_path}/implementations/AbstractTextureImplementation.h
	${source_path}/implementations/TextureImplementation_DirectStateAccessARB.cpp
	${source_path}/implementations/TextureImplementation_DirectStateAccessARB.h
	${source_path}/implementations/TextureImplementation_DirectStateAccessEXT.cpp
	${source_path}/implementations/TextureImplementation_DirectStateAccessEXT.h
	${source_path}/implementations/TextureImplementation_Legacy.cpp
	${source_path}/implementations/TextureImplementation_Legacy.h
    
    ${source_path}/implementations/AbstractTextureStorageImplementation.cpp
	${source_path}/implementations/AbstractTextureStorageImplementation.h
	${source_path}/implementations/TextureStorageImplementation_DirectStateAccessARB.cpp
	${source_path}/implementations/TextureStorageImplementation_DirectStateAccessARB.h
	${source_path}/implementations/TextureStorageImplementation_DirectStateAccessEXT.cpp
	${source_path}/implementations/TextureStorageImplementation_DirectStateAccessEXT.h
	${source_path}/implementations/TextureStorageImplementation_Legacy.cpp
	${source_path}/implementations/TextureStorageImplementation_Legacy.h
	${source_path}/implementations/TextureStorageImplementation_Fallback.cpp
	${source_path}/implementations/TextureStorageImplementation_Fallback.h

	${source_path}/implementations/AbstractUniformImplementation.cpp
	${source_path}/implementations/AbstractUniformImplementation.h
	${source_path}/implementations/UniformImplementation_Legacy.cpp
	${source_path}/implementations/UniformImplementation_Legacy.h
	${source_path}/implementations/UniformImplementation_SeparateShaderObjectsARB.cpp
	${source_path}/implementations/UniformImplementation_SeparateShaderObjectsARB.h
	
	${source_path}/implementations/AbstractVertexAttributeBindingImplementation.cpp
	${source_path}/implementations/AbstractVertexAttributeBindingImplementation.h
	${source_path}/implementations/VertexAttributeBindingImplementation_DirectStateAccessARB.cpp
	${source_path}/implementations/VertexAttributeBindingImplementation_DirectStateAccessARB.h
	${source_path}/implementations/VertexAttributeBindingImplementation_VertexAttribBindingARB.cpp
	${source_path}/implementations/VertexAttributeBindingImplementation_VertexAttribBindingARB.h
	${source_path}/implementations/VertexAttributeBindingImplementation_Legacy.cpp
	${source_path}/implementations/VertexAttributeBindingImplementation_Legacy.h

	${source_path}/IncludeProcessor.cpp
	${source_path}/IncludeProcessor.h
	${source_path}/LocationIdentity.cpp
	${source_path}/NamedString.cpp
	${source_path}/Object.cpp
	${source_path}/objectlogging.cpp
	${source_path}/ObjectVisitor.cpp
	${source_path}/pixelformat.cpp
	${source_path}/pixelformat.h
	${source_path}/ProgramBinary.cpp
	${source_path}/Program.cpp
	${source_path}/ProgramPipeline.cpp
	${source_path}/Query.cpp
	${source_path}/registry/ObjectRegistry.h
	${source_path}/registry/ExtensionRegistry.h
	${source_path}/registry/NamedStringRegistry.cpp
	${source_path}/registry/ImplementationRegistry.cpp
	${source_path}/registry/ExtensionRegistry.cpp
	${source_path}/registry/ObjectRegistry.cpp
	${source_path}/registry/NamedStringRegistry.h
	${source_path}/registry/ImplementationRegistry.h
	${source_path}/registry/Registry.cpp
	${source_path}/registry/Registry.h
	${source_path}/AttachedRenderbuffer.cpp
	${source_path}/Renderbuffer.cpp
	${source_path}/Resource.cpp
	${source_path}/Resource.h
	${source_path}/Sampler.cpp
	${source_path}/Shader.cpp
	${source_path}/State.cpp
	${source_path}/StateSetting.cpp
	${source_path}/Sync.cpp
	${source_path}/AttachedTexture.cpp
	${source_path}/Texture.cpp
	${source_path}/TextureHandle.cpp
	${source_path}/TransformFeedback.cpp
	${source_path}/UniformBlock.cpp
	${source_path}/VertexArray.cpp
	${source_path}/VertexAttributeBinding.cpp
)

# Group source files
set(header_group "Header Files (API)")
set(source_group "Source Files")
source_group_by_path(${include_path} "\\\\.h$|\\\\.inl$" 
    ${header_group} ${headers})
source_group_by_path(${source_path}  "\\\\.cpp$|\\\\.c$|\\\\.h$|\\\\.inl$" 
    ${source_group} ${sources})


# 
# Create library
# 

# Build library
add_library(${target}
    ${sources}
    ${headers}
)

# Create namespaced alias
add_library(${META_PROJECT_NAME}::${target} ALIAS ${target})

# Export library for downstream projects
export(TARGETS ${target} NAMESPACE ${META_PROJECT_NAME}:: FILE ${PROJECT_BINARY_DIR}/cmake/${target}/${target}-export.cmake)

# Create API export header
generate_export_header(${target}
    EXPORT_FILE_NAME  ${export_file}
    EXPORT_MACRO_NAME ${export_macro}
)

# Create feature detection header
# Create feature detection header
if (WriterCompilerDetectionHeaderFound)

=== source/tests/CMakeLists.txt ===

# 
# Setup test environment
# 

# Check if tests are enabled
if(NOT OPTION_BUILD_TESTS)
    return()
endif()

# DISABLE CMP0037: Target names should not be reserved and should match a validity pattern.
cmake_policy(SET CMP0037 OLD)

# Function: Build test and add command to execute it via target 'test'
function(add_test_without_ctest target)
    add_subdirectory(${target})
    
    if(NOT TARGET ${target})
        return()
    endif()
    
    add_dependencies(test ${target})
    add_custom_command(TARGET test POST_BUILD 
        COMMAND $<TARGET_FILE:${target}> --gtest_output=xml:gtests-${target}.xml)
endfunction()

# Build gmock
set(gmock_build_tests           OFF CACHE BOOL "")
set(gtest_build_samples         OFF CACHE BOOL "")
set(gtest_build_tests           OFF CACHE BOOL "")
set(gtest_disable_pthreads      OFF CACHE BOOL "")
set(gtest_force_shared_crt      ON  CACHE BOOL "")
set(gtest_hide_internal_symbols OFF CACHE BOOL "")

add_subdirectory(googletest/googlemock)

# Create interface library to link against gmock
add_library(gmock-dev INTERFACE)

target_include_directories(gmock-dev
    SYSTEM INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/googletest/googletest/include
    ${CMAKE_CURRENT_SOURCE_DIR}/googletest/googlemock/include
)

target_link_libraries(gmock-dev
    INTERFACE
    gmock
)


# 
# Target 'test'
# 

add_custom_target(test)
set_target_properties(test PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD 1)


# 
# Tests
# 

add_test_without_ctest(globjects-test)

=== source/examples/commandlineoutput/CMakeLists.txt ===

# 
# External dependencies
# 

find_package(GLFW)
find_package(glbinding REQUIRED)


# 
# Executable name and options
# 

# Target name
set(target commandlineoutput)

# Exit here if required dependencies are not met
if (NOT GLFW_FOUND)
    message("Example ${target} skipped: GLFW not found")
    return()
endif()

message(STATUS "Example ${target}")


# 
# Sources
# 

set(sources
    main.cpp
)


# 
# Create executable
# 

# Build executable
add_executable(${target}
    ${sources}
)

# Create namespaced alias
add_executable(${META_PROJECT_NAME}::${target} ALIAS ${target})


# 
# Project options
# 

set_target_properties(${target}
    PROPERTIES
    ${DEFAULT_PROJECT_OPTIONS}
    FOLDER "${IDE_FOLDER}"
)


# 
# Include directories
# 

target_include_directories(${target}
    PRIVATE
    ${DEFAULT_INCLUDE_DIRECTORIES}
    ${PROJECT_BINARY_DIR}/source/include
    SYSTEM
    ${GLFW_INCLUDE_DIR}
)


# 
# Libraries
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LIBRARIES}
    ${GLFW_LIBRARIES}
    ${META_PROJECT_NAME}::globjects
)


# 
# Compile definitions
# 

target_compile_definitions(${target}
    PRIVATE
    ${DEFAULT_COMPILE_DEFINITIONS}
    GLFW_INCLUDE_NONE
)


# 
# Compile options
# 

target_compile_options(${target}
    PRIVATE
    ${DEFAULT_COMPILE_OPTIONS}
)


# 
# Linker options
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LINKER_OPTIONS}
)


# 
# Deployment
# 

# Executable
install(TARGETS ${target}
    RUNTIME DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
    BUNDLE  DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
)

=== source/examples/computeshader/CMakeLists.txt ===

# 
# External dependencies
# 

find_package(GLFW)
find_package(glbinding REQUIRED)


# 
# Executable name and options
# 

# Target name
set(target computeshader)

# Exit here if required dependencies are not met
if (NOT GLFW_FOUND)
    message("Example ${target} skipped: GLFW not found")
    return()
endif()

message(STATUS "Example ${target}")


# 
# Sources
# 

set(sources
    main.cpp
    ScreenAlignedQuad.h
    ScreenAlignedQuad.cpp
    datapath.inl
)


# 
# Create executable
# 

# Build executable
add_executable(${target}
    ${sources}
)

# Create namespaced alias
add_executable(${META_PROJECT_NAME}::${target} ALIAS ${target})


# 
# Project options
# 

set_target_properties(${target}
    PROPERTIES
    ${DEFAULT_PROJECT_OPTIONS}
    FOLDER "${IDE_FOLDER}"
)


# 
# Include directories
# 

target_include_directories(${target}
    PRIVATE
    ${DEFAULT_INCLUDE_DIRECTORIES}
    ${PROJECT_BINARY_DIR}/source/include
    SYSTEM
    ${GLFW_INCLUDE_DIR}
)


# 
# Libraries
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LIBRARIES}
    ${GLFW_LIBRARIES}
    ${META_PROJECT_NAME}::globjects
    cpplocate::cpplocate
)


# 
# Compile definitions
# 

target_compile_definitions(${target}
    PRIVATE
    ${DEFAULT_COMPILE_DEFINITIONS}
    GLFW_INCLUDE_NONE
)


# 
# Compile options
# 

target_compile_options(${target}
    PRIVATE
    ${DEFAULT_COMPILE_OPTIONS}
)


# 
# Linker options
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LINKER_OPTIONS}
)


# 
# Deployment
# 

# Executable
install(TARGETS ${target}
    RUNTIME DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
    BUNDLE  DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
)

=== source/examples/programpipelines/CMakeLists.txt ===

# 
# External dependencies
# 

find_package(GLFW)
find_package(glbinding REQUIRED)


# 
# Executable name and options
# 

# Target name
set(target programpipelines)

# Exit here if required dependencies are not met
if (NOT GLFW_FOUND)
    message("Example ${target} skipped: GLFW not found")
    return()
endif()

message(STATUS "Example ${target}")


# 
# Sources
# 

set(sources
    main.cpp
)


# 
# Create executable
# 

# Build executable
add_executable(${target}
    ${sources}
)

# Create namespaced alias
add_executable(${META_PROJECT_NAME}::${target} ALIAS ${target})


# 
# Project options
# 

set_target_properties(${target}
    PROPERTIES
    ${DEFAULT_PROJECT_OPTIONS}
    FOLDER "${IDE_FOLDER}"
)


# 
# Include directories
# 

target_include_directories(${target}
    PRIVATE
    ${DEFAULT_INCLUDE_DIRECTORIES}
    ${PROJECT_BINARY_DIR}/source/include
    SYSTEM
    ${GLFW_INCLUDE_DIR}
)


# 
# Libraries
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LIBRARIES}
    ${GLFW_LIBRARIES}
    ${META_PROJECT_NAME}::globjects
)


# 
# Compile definitions
# 

target_compile_definitions(${target}
    PRIVATE
    ${DEFAULT_COMPILE_DEFINITIONS}
    GLFW_INCLUDE_NONE
)


# 
# Compile options
# 

target_compile_options(${target}
    PRIVATE
    ${DEFAULT_COMPILE_OPTIONS}
)


# 
# Linker options
# 

target_link_libraries(${target}
    PRIVATE
    ${DEFAULT_LINKER_OPTIONS}
)


# 
# Deployment
# 

# Executable
install(TARGETS ${target}
    RUNTIME DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
    BUNDLE  DESTINATION ${INSTALL_EXAMPLES} COMPONENT examples_glfw
)

=== debian/changelog ===
globjects (1.1.0-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:04:20 +0100

globjects (1.1.0-3) unstable; urgency=medium

  * Team upload
  * Allow output to stderr, because of new cmake complaining
    wrt CMP0037 being deprecated

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Jul 2018 10:51:56 +0200

globjects (1.1.0-2) unstable; urgency=medium

  * Bump standards version to 4.0.0, no changes required
  * Add support for the nodoc build profile
  * Release to unstable

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 20 Jul 2017 09:42:26 +0100

globjects (1.1.0-1) experimental; urgency=medium

  * New upstream version 1.1.0
  * Fixup the Vcs-Browser URI
  * Release to experimental

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 21 Mar 2017 15:36:59 +0000

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,12 @@
 Priority: optional
 Build-Depends: cmake (>= 3.0),
                debhelper (>= 10),
+               dpkg-dev (>= 1.17.14),
                libglbinding-dev,
-               libglm-dev 
-Build-Depends-Indep: doxygen
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/globjects.git
+               libglm-dev
+Build-Depends-Indep: doxygen <!nodoc>
+Standards-Version: 4.0.0
+Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/globjects.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/globjects.git
 Homepage: https://github.com/cginternals/globjects
 
@@ -37,7 +38,7 @@
 Depends: ${misc:Depends},
          libglbinding-dev,
          libglobjects1 (= ${binary:Version})
-Suggests: globjects-doc
+Suggests: globjects-doc <!nodoc>
 Description: development files for globjects
  globjects provides object-oriented interfaces to the OpenGL API (3.0 and
  higher). The main goals are much reduced code to use OpenGL in your
@@ -65,3 +66,4 @@
  even emulated.
  .
  This package provides the documentation.
+Build-Profiles: <!nodoc>

=== debian/rules ===
--- 
+++ 
@@ -26,8 +26,12 @@
 	dh_auto_configure -- $(BUILD_OPTIONS) -DOPTION_BUILD_DOCS=OFF
 
 override_dh_auto_configure-indep:
+ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
 	dh_auto_configure -- $(BUILD_OPTIONS) -DOPTION_BUILD_DOCS=ON
+endif
 
 override_dh_installdocs-indep:
 	dh_installdocs --indep
+ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
 	dh_doxygen --indep
+endif

=== debian/tests/control ===
Tests: globjects-tests
Depends: @, cmake, g++ | c++-compiler
Restrictions: allow-stderr
